## mysql-community 8.0.27

=== debian/changelog ===
mysql-community (8.0.27-1debian11) bullseye; urgency=low

  * New Release. For release notes, please refer to
    https://dev.mysql.com/doc/relnotes/mysql/8.0/en/news-8-0-27.html

 -- MySQL Release Engineering <mysql-build@oss.oracle.com>  Tue, 28 Sep 2021 13:26:22 +0000
