=== debian/rules ===
--- 
+++ 
@@ -125,11 +125,9 @@
 	@echo "RULES.$@"
 	
 	
-	dh_systemd_enable --name=mysql
-	dh_installinit --name=mysql -- defaults 19 21
-	dh_installinit --name=mysql@ -- disable
+	dh_installsystemd --name=mysql
+	dh_installsystemd --name=mysql@ --no-enable --no-start
 	dh_installinit --name=mysqlrouter -- defaults 19 21
-	dh_systemd_start --restart-after-upgrade
 	touch $@
 
 override_dh_install:
@@ -145,3 +143,7 @@
 # for both.
 override_dh_strip:
 	dh_strip -Xlibprotobuf-lite
+
+# Debug plugins use libprotobuf-lite from the server package.
+override_dh_shlibdeps:
+	dh_shlibdeps -Lmysql-community-server-core -l/usr/lib/mysql/private
