## mysql-community 8.0.31

=== debian/changelog ===
mysql-community (8.0.31-1debian10) buster; urgency=low

  * New Release. For release notes, please refer to
    https://dev.mysql.com/doc/relnotes/mysql/8.0/en/news-8-0-31.html

 -- MySQL Release Engineering <mysql-build@oss.oracle.com>  Tue, 13 Sep 2022 16:58:35 +0000
