=== debian/control ===
--- 
+++ 
@@ -14,6 +14,7 @@
  po-debconf,
  psmisc,
  bison,
+ elfutils,
  lsb-release,
  cmake,
  fakeroot,
