## mysql-community 8.0.32

=== debian/changelog ===
mysql-community (8.0.32-1debian10) buster; urgency=low

  * New Release. For release notes, please refer to
    https://dev.mysql.com/doc/relnotes/mysql/8.0/en/news-8-0-32.html

 -- MySQL Release Engineering <mysql-build@oss.oracle.com>  Fri, 16 Dec 2022 16:07:04 +0000
