=== debian/control ===
--- 
+++ 
@@ -90,6 +90,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Breaks: mysql-community-server (<< 8.0.1),
  mysql-commercial-server (<< 8.0.1),
+ mysql-common (<< 8.0.32)
 Conflicts: mysql,
  mysql-server-core-5.7,
  mysql-server-core-8.0,
@@ -100,6 +101,7 @@
 Replaces: mysql-community-server (<< 8.0.1),
  mysql-commercial-server (<< 8.0.1),
  mysql-commercial-server-core,
+ mysql-common (<< 8.0.32),
  mysql-server-core-5.7,
  mysql-server-core-8.0
 Provides: virtual-mysql-server-core
@@ -294,5 +296,3 @@
 Architecture: any
 Depends: mysql-community-server (= ${binary:Version}),
  mysql-community-client (= ${binary:Version}),
- libmysqlclient-dev, libjson-perl, mecab-ipadic-utf8,
- ${shlibs:Depends}, ${misc:Depends},
