=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-# Copyright (c) 2015, 2021, Oracle and/or its affiliates.
+# Copyright (c) 2015, 2022, Oracle and/or its affiliates.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License, version 2.0,
@@ -40,7 +40,7 @@
 	
 	mkdir debug && cd debug && \
 	cmake .. \
-      -DWITH_BOOST=/usr/global/share -DWITH_GMOCK=/usr/global/share \
+    -DWITH_BOOST=/usr/global/share -DWITH_GMOCK=/usr/global/share \
 		-DBUILD_CONFIG=mysql_release \
 		-DCMAKE_INSTALL_PREFIX=/usr \
 		-DCMAKE_BUILD_TYPE=Debug \
@@ -62,7 +62,7 @@
 
 	mkdir release && cd release && \
 	cmake .. \
-      -DWITH_BOOST=/usr/global/share -DWITH_GMOCK=/usr/global/share \
+    -DWITH_BOOST=/usr/global/share -DWITH_GMOCK=/usr/global/share \
 		-DBUILD_CONFIG=mysql_release \
 		-DCMAKE_INSTALL_PREFIX=/usr \
 		-DINSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) \
